#!/bin/bash
# SQLUX Config GUI 
 
declare -a select 
declare -a afirst
declare -a alast
declare -i z
declare -i len

ini=~/sQLux/sqlux.ini
init="~/sQLux/sqlux.ini"

if [ ! -f "$ini" ]; then
cat << EOF > $ini
ROMDIR = $HOME/sQLux/roms
SYSROM = MIN198.rom
ROMIM = TK236.rom
RAMTOP = 4096
MDV1 = MDV1,~/sQLux/examples/mdv1,qdos-like
MDV2 = MDV2,~/sQLux/examples/mdv2,qdos-like
#FLP1 =
#FLP2 =
#WIN1 =
#WIN2 =
#WIN7 =
#WIN8 =
BOOT_DEVICE = MDV1
RESOLUTION = 512x256
WIN_SIZE = 2x
KBD = US
FILTER = 1
FIXASPECT = 1
EOF
fi

readarray -t select < $ini

z=0
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]##*= } )
else 
afirst[z]='ROMDIR'
fi
echo $z ${afirst[z]} ${alast[z]}

z=1
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]#*=} )
else 
afirst[z]='SYSROM'
fi
echo $z:${afirst[z]}:${alast[z]}:

z=2
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} || '#' ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]#*=} )
else 
afirst[z]='ROMIM'
fi
echo $z:${afirst[z]}:${alast[z]}:

z=3
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
afirst[z]=$( echo ${select[z]%=*} )
alast[z]=$( echo ${select[z]##*=} )
else
afirst[z]='RAMTOP'
fi
echo $z ${afirst[z]} ${alast[z]}

z=4
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='MDV1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}

z=5
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='MDV2'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}

z=6
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='FLP1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}

z=7
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='FLP2'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}

z=8
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN1'
alast[z]=''
fi
echo $z ${afirst[z]} ${alast[z]}

z=9
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN2'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}

z=10
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN7'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}

z=11
hash[z]=$( echo ${select[z]:0:1} )
if [[ ${hash[z]} != "#" ]];then
dev=$( echo ${select[z]##*=} )
afirst[z]=$( echo $dev |awk '{split($0,a,","); print a[1]}')
alast[z]=$( echo $dev |awk '{split($0,a,","); print a[2]}')
else
afirst[z]='WIN8'
alast[z]=''
fi
echo $z:${afirst[z]}:${alast[z]}

z=12
afirst[z]=$( echo ${select[z]%=*} )
boot=$(echo ${select[z]##*= } )
boot=$(echo $boot\!MDV1\!FLP1\!WIN1 )
echo $z  ${afirst[z]} $boot

z=13
afirst[z]=$( echo ${select[z]%=*} )
res=$( echo ${select[z]##*= } )
res=$( echo $res\!512x256\!512x512\!640x400\!800x600\!1024x800 ) 
echo $z  ${afirst[z]} $res

z=14
afirst[z]=$( echo ${select[z]%=*} )
size=$( echo ${select[z]##*= } )
size=$( echo $size\!1x\!2x\!3x\!max\!full )
echo $z  ${afirst[z]} $size

z=15
afirst[z]=$( echo ${select[z]%=*} )
lang=$( echo ${select[z]##*= } )
lang=$( echo $lang\!GB\!US\!DE\!ES )
echo $z  ${afirst[z]} $lang

z=16
afirst[z]=$( echo ${select[z]%=*} )
filter=$( echo ${select[z]##*= } )
filter=$( echo $filter\!1\!0 )
echo $z  ${afirst[z]} $filter

z=17
afirst[z]=$( echo ${select[z]%=*} )
aspect=$( echo ${select[z]##*= } )
aspect=$( echo $aspect\!1\!0 )
echo $z  ${afirst[z]} $aspect

yad	--form  --separator='\n' \
	--title="uQLX config ""$init" \
	--center --width=600  --height=600 \
	--file-filter "*.rom *.ROM" \
	--image-on-top --image="~/sQLux/sQLuxLogo.png" \
	--field=" "${afirst[0]}:FLE  "${alast[0]}"  \
	--field=" "${afirst[1]}:FLE  "${alast[1]}" \
	--field=" "${afirst[2]}:FLE  "${alast[2]}" \
	--field=" "${afirst[3]}:NUM  "${alast[3]}"!640..16000!512 \
	--field=" "${afirst[4]}:FLE  "${alast[4]}" \
	--field=" "${afirst[5]}:FLE  "${alast[5]}" \
	--field=" "${afirst[6]}:FLE  "${alast[6]}" \
	--field=" "${afirst[7]}:FLE  "${alast[7]}" \
	--field=" "${afirst[8]}:FLE  "${alast[8]}" \
	--field=" "${afirst[9]}:FLE  "${alast[9]}" \
	--field=" "${afirst[10]}:DIR "${alast[10]}" \
	--field=" "${afirst[11]}:DIR "${alast[11]}" \
	--field=' BOOT:':CBE 		$boot \
	--field=' RESOLUTION:'CBE   $res \
	--field=' WIN SIZE':CBE     $size \
	--field=' KEYBOARD':CBE     $lang \
	--field=' FILTER:'CB        $filter \
	--field=' FIXASPECT:'CB     $aspect \
	--field=' PATH TO SQLUX':DIR ~/sQLux/build \ > ~/test.txt 
	ret=$?
   
[[ $ret -eq 1 ]] && exit
[[ $ret -eq 252 ]] && exit


readarray -t select < ~/test.txt 
echo
romdir="${alast[0]}"

if [[ -z ${select[1]} ]];then
romim='MIN198.rom'
else
basefilename=${select[1]}
ext="${basefilename##*.}"
realname=$(basename "${basefilename%.*}")
sysrom=$realname.$ext
fi

if [[ -z ${select[2]} ]];then
romim=''
else 
romim=${select[2]}
fi

echo '1'  $romdir
echo '2'  $sysrom
echo '3'  $romim
echo '4'  ${select[4]}
echo '5'  ${select[5]}
echo '6'  ${select[6]}
echo '7'  ${select[7]}
echo '8'  ${select[8]}
echo '9'  ${select[9]}
echo '10' ${select[10]}
echo '11' ${select[11]}
echo '12' ${select[12]}
echo '13' ${select[13]}
echo '14' ${select[14]}
echo '15' ${select[15]}
echo '16' ${select[16]}
echo '17' ${select[17]}
echo '18' ${select[18]}
echo '19' ${select[19]}

DIR=${select[18]}

z=4
if [[ -z ${select[z]} ]];then 
MDV1='#DEVICE = MDV1,'
else
MDV1='DEVICE = MDV1,'${select[z]}',qdos-like'
fi
z=5
if [[ -z ${select[5]} ]];then 
MDV2='#DEVICE = MDV2,'
else
MDV2='DEVICE = MDV2,'${select[5]}',qdos-like'
fi
z=6
if [[ -z ${select[z]} ]];then 
FLP1='#DEVICE = FLP1,'
else
FLP1='DEVICE = FLP1,'${select[z]}',qdos-fs'
fi

z=7
if [[ -z ${select[z]} ]];then 
FLP2='#DEVICE = FLP2,'
else
FLP2='DEVICE = FLP2,'${select[z]}',qdos-fs'
fi
z=8
if [[ -z ${select[z]} ]];then 
WIN1='#DEVICE = WIN1,'
else
WIN1='DEVICE = WIN1,'${select[z]}',qdos-fs'
fi
z=9
if [[ -z ${select[z]} ]];then 
WIN2='#DEVICE = WIN2,'
else
WIN2='DEVICE = WIN2,'${select[z]}',qdos-fs'
fi
z=10
if [[ -z ${select[z]} ]];then 
WIN7='#DEVICE = WIN7,'
else
WIN7='DEVICE = WIN7,'${select[z]}
fi
z=11
if [[ -z ${select[z]} ]];then 
WIN8='#DEVICE = WIN8,'
else
WIN8='DEVICE = WIN8,'${select[z]}
fi

cat << EOF > $ini
ROMDIR = $romdir
SYSROM = $sysrom           			
ROMIM = $romim						
RAMTOP = ${select[3]}				
$MDV1								
$MDV2								
$FLP1								
$FLP2									
$WIN1								
$WIN2								
$WIN7
$WIN8
BOOT_DEVICE = ${select[12]}			
RESOLUTION = ${select[13]}
WIN_SIZE = ${select[14]}
KBD = ${select[15]}
FILTER = ${select[16]}
FIXASPECT = ${select[17]}
EOF

cat $ini

$DIR/sqlux  -f $ini
